#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: common.py,v 1.4 2004/01/12 18:12:40 nes Exp $

import sys
import logging

options = None
action = None
action_args = []

EXIT_OK              = 0 # everything is ok.
EXIT_MISC            = 1 # misc errors.
EXIT_XML             = 2 # xml parsing or validating error.
EXIT_CMDLINE         = 3 # the options passed to vampire are not correct.
EXIT_CONNECTION      = 4 # the vampire client can't connect to the server.

logger = logging.getLogger('vampire')
# This temporary handler is used to log things before the command line
# has been parsed.
__tmphdlr = logging.StreamHandler(sys.stderr)
logger.addHandler(__tmphdlr)

def initialize_logger(stream):
    global logger, options
    logger.removeHandler(__tmphdlr)
    hdlr = logging.StreamHandler(stream)
    formatter = logging.Formatter('[%(levelname)s] %(message)s')
    hdlr.setFormatter(formatter)
    logger.addHandler(hdlr)
    if options.debug:
        logger.setLevel(logging.DEBUG)
    elif options.do_nothing or options.verbose:
        logger.setLevel(logging.INFO)
    else:
        logger.setLevel(logging.WARNING)
