#    Copyright (C) 2003, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: InfoBalise.py,v 1.1 2004/01/10 15:13:06 nes Exp $

"""
This module was created in order to describe any XML schema for own validator.
"""

# Classe decrivant pour une balise, les balises qui peut ou doit contenir, idem
# pour les attributs et si il peut aussi contenir du data
class InfoBalise:
    ## ACCESSORS ##
    def GetInfoBal(self):
        return self.__InfoBal

    def GetRequiredAttr(self, Name):
        if (self.__InfoBal.has_key(Name)):
            return self.__InfoBal[Name][0]
	else:
	    return []

    def GetOptionalAttr(self, Name):
        if (self.__InfoBal.has_key(Name)):
            return self.__InfoBal[Name][1]
	else:
	    return []

    def GetRequiredBalise(self, Name):
        if (self.__InfoBal.has_key(Name)):
            return self.__InfoBal[Name][2]
	else:
	    return []

    def GetOptionalBalise(self, Name):
        if (self.__InfoBal.has_key(Name)):
            return self.__InfoBal[Name][3]
	else:
	    return []

    def IsAllowData(self, Name):
        if (self.__InfoBal.has_key(Name)):
            return self.__InfoBal[Name][4]
	else:
	    return 0

    ## METHODS ##
    def __IsInList(self, List, Elt):
        for i in List:
	    if (Elt == i):
	        return 1
	return 0

    def __IsInListAR(self, Name, Elt):
        return self.__IsInList(self.GetRequiredAttr(Name), Elt)

    ## METHODS ##
    def __IsInListAO(self, Name, Elt):
        return self.__IsInList(self.GetOptionalAttr(Name), Elt)

    def IsRightAttr(self, Name, Attr):
        ListAttr = self.GetRequiredAttr(Name)
	for i in ListAttr:
	    if (not Attr.has_key(i)):
	        return "R" + i
	for i in Attr.keys():
	    if ((not self.__IsInListAR(Name, i)) and
	        (not self.__IsInListAO(Name, i))):
	        return "O" + i
	return ""

    def IsRightBalise(self, Father, Current):
        if (Father == ""):
	    return Current == self.__BaliseRoot
	if (self.__IsInList(self.GetRequiredBalise(Father), Current)):
	    return 1
	if (self.__IsInList(self.GetOptionalBalise(Father), Current)):
	    return 1
	return 0

    def IsRightData(self, Name, Data):
        while ((Data[:1] == " ") or (Data[:1] == "\t") or (Data[:1] == "\n")):
	    Data = Data[1:]
        if (self.IsAllowData(Name) == 0):
	    return Data == ""
        return 1

    ## CONSTRUCTEUR ##
    def __init__(self, Root, InfoBal):
        self.__BaliseRoot = Root
        self.__InfoBal = InfoBal
