#    Copyright (C) 2003, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    $Id: Location.py,v 1.1 2004/01/10 15:13:06 nes Exp $

"""
This module was created in order to help the XML parser. In deed, the
expat Parser can't localize a balise in file except the expat parser
raise exception. So, with this module could find a balise in file, it
gives the line and column in this file.
"""

import sys

def __ThrowResult(f, Line, Col):
    """
    * Bugs: None

    * Exceptions raised: None

    * Exceptions intercepted: None

    * Brief: This method encapsules the exit module. It cleans all (close
    read) and it returns an array with a length 2. In the first
    case, there is a line number and in the last, the number column.

    If the balise wasn't find, we return [-1,-1]. (We could also
    raise a exception, it would be prettier).

    @param f: Name of file (will close)
    @type f: string
    @param Line: Number of line (will return)
    @type Line: integer
    @param Col: Number of column (will return)
    @type Col: integer
    @return: an arrray of integer with length 2
    """
    if (f != None):
        f.close()
    return [Line, Col]

def GetLocationBegin(File, Balise, i):
    """
    * Bugs: None

    * Exceptions raised: None

    * Exceptions intercepted: None

    * Brief: Get Location (Line, Column) of i th entering balise in XML file,
    when we don't find, we return [-1, -1]

    @param File: File name where we work
    @type File: string
    @param Balise: Beginning balise name which we try to find
    @type Balise: string
    @param i: The i th balise which we try to find
    @type i: integer
    @return: an arrray of integer with length 2 (throught the function
    __ThrowResult)
    """

    flux = None
    if (i == 0):
        __ThrowResult(flux, -1, -1)
    BEGIN_COMMENT = "<!--"	# Debut d'un commentaire XML
    END_COMMENT = "-->"		# Fin d'un commentaire XML
    Col  = 1 # Colonne courante
    Line = 1 # Ligne courante
    Cmmt = 0 # A vrai si on est dans un commentaire
    OutC = 0 # A vrai si on sort ou entre dans un commentaire on reprend le
    	     # traitement de la ligne a l'endroit ou on s'est arrete
    j	 = 1 # Compteur de balise
    flux = open(File, "r")
    FLine = flux.readline()
    while ((FLine != "") or (OutC == 1)):
        OutC = 0
        if (Cmmt):
	   while (FLine != ""):
	       if (FLine[:len(END_COMMENT)] == END_COMMENT):
	           OutC = 1
		   Cmmt = 0
		   break
	       Col += 1
	       FLine = FLine[1:]
	else:
	   while (FLine != ""):
	       if (FLine[:len(BEGIN_COMMENT)] == BEGIN_COMMENT):
	           Cmmt = 1
		   OutC = 1
		   break
	       elif ((FLine[:len(Balise) + 2] == ("<" + Balise + ">"))  or
	             (FLine[:len(Balise) + 2] == ("<" + Balise + " "))  or
	             (FLine[:len(Balise) + 2] == ("<" + Balise + "\t")) or
	             (FLine[:len(Balise) + 2] == ("<" + Balise + "\n"))):
		   if (i == j):
		       return __ThrowResult(flux, Line, Col)
		   else:
		       j += 1
	       Col += 1
	       FLine = FLine[1:]
	if (OutC == 0):
	    Line += 1
	    Col = 0
	    FLine = flux.readline()
    return __ThrowResult(flux, -1, -1)

def GetLocationEnd(File, Balise, i):
    """
    * Bugs: None

    * Exceptions raised: None

    * Exceptions intercepted: one

    * Brief: Get Location of i th closing balise in XML file, when we don't
    find, we return [-1, -1]

    @param File: File name where we work
    @type File: string
    @param Balise: Ending balise name which we try to find
    @type Balise: string
    @param i: The i th balise which we try to find
    @type i: integer
    @return: an arrray of integer with length 2 (throught the function
    __ThrowResult)
    """
    flux = None
    if (i == 0):
        __ThrowResult(flux, -1, -1)
    BEGIN_COMMENT = "<!--"	# Debut d'un commentaire XML
    END_COMMENT = "-->"		# Fin d'un commentaire XML
    Col  = 1 # Colonne courante
    Line = 1 # Ligne courante
    Cmmt = 0 # A vrai si on est dans un commentaire
    OutC = 0 # A vrai si on sort ou entre dans un commentaire on reprend le
    	     # traitement de la ligne a l'endroit ou on s'est arrete
    j	 = 1 # Compteur de balise
    Hole = 0 # Balise like as <toto />
    flux = open(File, "r")
    FLine = flux.readline()
    while ((FLine != "") or (OutC == 1)):
        OutC = 0
        if (Cmmt == 1):
	   while (FLine != ""):
	       if (FLine[:len(END_COMMENT)] == END_COMMENT):
	           OutC = 1
		   Cmmt = 0
		   break
	       Col += 1
	       FLine = FLine[1:]
	if (Hole == 1):
	    while (FLine != ""):
	        if (FLine[:2] == "/>"):
		    if (i == j):
		        return __ThrowResult(flux, Line, Col)
		    else:
		        j += 1
		elif (FLine[:1] == ">"):
		    Hole = 0
		    OutC = 1
		    break
	        Col += 1
	        FLine = FLine[1:]
	else:
	    while (FLine != ""):
	        if (FLine[:len(BEGIN_COMMENT)] == BEGIN_COMMENT):
	            Cmmt = 1
		    OutC = 1
		    break
	        elif ((FLine[:len(Balise) + 3] == ("</" + Balise + ">"))  or
	              (FLine[:len(Balise) + 3] == ("</" + Balise + " "))  or
	              (FLine[:len(Balise) + 3] == ("</" + Balise + "\t")) or
	              (FLine[:len(Balise) + 3] == ("</" + Balise + "\n"))):
		    if (i == j):
		        return __ThrowResult(flux, Line, Col)
		    else:
		        j += 1
	        elif ((FLine[:len(Balise) + 2] == ("<" + Balise + " "))  or
	              (FLine[:len(Balise) + 2] == ("<" + Balise + "\t")) or
	              (FLine[:len(Balise) + 2] == ("<" + Balise + "\n"))):
		    Hole = 1
		    OutC = 1
		    break
	        Col += 1
	        FLine = FLine[1:]
	if (OutC == 0):
	    Line += 1
	    Col = 0
	    FLine = flux.readline()
    return __ThrowResult(flux, -1, -1)

# TEST
if __name__ == "__main__":
    R = GetLocationBegin(sys.argv[1], sys.argv[2], int(sys.argv[3]))
    print sys.argv[0] + ": " + sys.argv[1] + ": Find " + str(sys.argv[3]) + "th `" + sys.argv[2] + "': Line " + str(R[0]) + ", Column " + str(R[1])
    R = GetLocationEnd(sys.argv[1], sys.argv[2], int(sys.argv[3]))
    print sys.argv[0] + ": " + sys.argv[1] + ": Find " + str(sys.argv[3]) + "th `" + sys.argv[2] + "': Line " + str(R[0]) + ", Column " + str(R[1])
