#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: PrintMsg.py,v 1.3 2004/01/10 17:00:21 nes Exp $

"""
This module was created in order to format all of Vampire message (after
we could parse this log of vampire). Moreover for each level print we do
generic action (except the printing), or we do action follows shell options,
for example we print nothing in normal mode with the mode silent.
"""

import sys
import common
from common import *

STR_EXEC=""

# Messages d'erreurs
STR_ERROR="ERROR: "

# Messages de succes
STR_SUCCEED="Successfully "

# Messages d'avertissement
STR_WARN="WARNING: "

# Generic Methods
def VError(Location, Msg):
    """
    To print a error message and do actions after error (exit)
    @param Location: Name of module where the message was broaded
    @param Msg: The data message
    """
    print STR_EXEC + Location + ": " + STR_ERROR + Msg
    sys.exit(common.EXIT_XML)

def VWarning(Location, Msg):
    """
    To print a warning message and do actions after warning
    @param Location: Name of module where the message was broaded
    @param Msg: The data message
    """
    print STR_EXEC + Location + ": " + STR_WARN + Msg
    #FIXME: Code to exit after warning

def VSucceed(Location, Msg):
    """
    To print a normal message and do actions following option (example
    the silent mode)
    @param Location: Name of module where the message was broaded
    @param Msg: The data message
    """
    #FIXME: If silent do nothing
    logger.info (STR_EXEC + Location + ": " + STR_SUCCEED + Msg)

# Particulars Methods, but we do try to pass with Genericq Methods into
# this methods

# WARNING XML PARSER
XML_WARN_MSG1="Multiple objects definitions"
XML_WARN_MSG2="Multiple attributs"

# ERROR XML PARSER
XML_ERROR_MSG1="Unknown balise"
XML_ERROR_MSG2="Unexcepted balise"
XML_ERROR_MSG3="Unexcepted data"
XML_ERROR_MSG4="Bad typage, except type"
XML_ERROR_MSG5="Excepted attributs"
XML_ERROR_MSG6="Unexcepted attributs"
XML_ERROR_MSG7="Excepted balise"
XML_ERROR_MSG8="Bad number balise"

def GetCodeXMLUnknowBal(Balise):
    return XML_ERROR_MSG1 + " `" + Balise + "'"

def GetCodeXMLUnexcpBal(Father, Balise):
    return XML_ERROR_MSG2 + " `" + Balise + "' in `" + Father + "'"

def GetCodeXMLUnexcpBalBis(Father, Balise):
    return XML_ERROR_MSG2 + " `" + Balise + "' in `" + Father + "'"

def GetCodeXMLUnexcpData(Balise, Data):
    return XML_ERROR_MSG3 + " in `" + Balise + "' has `" + Data + "'"

def GetCodeXMLTypage(ExceptType, Value):
    return XML_ERROR_MSG4 + " `" + ExceptType + "' but receive value `" + Value + "'"

def GetCodeXMLExceptAttr(ExceptAttr, Name):
    return XML_ERROR_MSG5 + " `" + ExceptAttr + "' into balise `" + Name + "'"

def GetCodeXMLUnexcpAttr(Attr, Name):
    return XML_ERROR_MSG6 + " `" + Attr + "' into balise `" + Name + "'"

def GetCodeXMLExceptBal(Balise, Father):
    return XML_ERROR_MSG7 + " `" + Balise + "' into balise `" + Father + "'"

def GetCodeXMLExceptBalBis(Balise, i, Interval):
    return XML_ERROR_MSG8 + " `" + Balise + "', we have " + str(i) + " but we must have " + Interval

def ErrorXML(File, Line, Col, Code):
    VError(File, "Line " + str(Line) + ", Column " + str(Col) + ": " + Code)

def GetCodeXMLMultipleDef(Object, Balise):
    return XML_WARN_MSG1 + " of `" + Object + "' into balise `" + Balise + "'"

def GetCodeXMLMultipleAttr(Attr, Balise):
    return XML_WARN_MSG2 + " of `" + Attr + "' into balise `" + Balise + "'"

def WarningXML(File, Line, Col, Code):
    VWarning(File, "Line " + str(Line) + ", Column " + str(Col) + ": " + Code)


# WARNING XML PARSER
XML_WARN_MSG1="Multiple definition"

# SUCCEDD XML PARSER
XML_SUCCEED_MSG1="parsed"

def SuccessXML(File):
    VSucceed(File, XML_SUCCEED_MSG1)
