#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: Tarball.py,v 1.3 2004/01/10 17:00:21 nes Exp $

# FIXME: this file is used only in the parser. It should either be
# renamed or moved elsewhere I think.

from core import TarballCommand

class Tarball:
    def AddVar(self, Var, Value, Restriction = None):
        if (not self.__DicVar.has_key(Var)):
	    self.__DicVar[Var] = [(Value, Restriction)]
	else:
            self.__DicVar[Var].append((Value, Restriction))

    def AddCmd(self, Cmd):
        self.__ListCmd.append(Cmd)

    def AddTestOs(self, Os):
        self.__TestOS = Os

    def getName(self):
	return self.__Name

    def getClass(self):
	return self.__Class

    def getVar(self):
	return self.__DicVar

    def getCmd(self):
	return self.__ListCmd

    def getTestOS(self):
        if self.__TestOS != "":
            if self.__check_pattern(self.__TestOS):
                return self.__TestOS
            else:
                import sys, misc
                common.logger.error ("Pattern \"%s\" is not correct" \
                                 % self.__TestOS)
                sys.exit(common.EXIT_XML)
        return ".*"

    def __check_pattern(self, pattern):
        import re, sre_constants
        try:
            re.match(pattern, "")
        except sre_constants.error:
            return False
        return True

    ## CONSTRCUTOR ##
    def __init__(self, Name, Class):
        self.__Name = Name
	self.__Class = Class
        self.__DicVar	= {}
	self.__ListCmd	= []
	self.__TestOS	= ""

    ## DEBUG ##
    def __str__(self):
        StrDicVar	= "  List of variable:\n"
	StrListCmd	= "  List of build command:\n"
	StrListTestOs	= "  Testable OS:\n"

        for i in self.__DicVar:
	    StrDicVar += "    " + i + "=" + self.__DicVar[i] + "\n"
        for i in self.__ListCmd:
	    StrListCmd += "    " + str(i) + "\n"
        for i in self.__TestOS:
	    StrListTestOs += "    " + str(i) + "\n"
	return "State tarball `" + self.__Name + "' from class `" + self.__Class + "'\n" + StrDicVar + StrListCmd + StrListTestOs
