#    Copyright (C) 2003, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: TarballCommand.py,v 1.1 2004/01/10 17:00:21 nes Exp $


class CmdTask:
    """
    Class for information commands (print, fetch and abort) used after the
    execution of a command in a test. They ares defined in 'onfail' and
    'onsuccess' fields in the configuration file of tarballs.
    """
    ## CONSTRUCTOR ##
    def __init__(self, Name, Arg = "", Type = ""):
    	self.__Name	= Name
        self.__Arg = Arg
        self.__Type = Type

    ## ACCESSORS ##
    def getName(self):
        """accessor"""
        return self.__Name

    def setName(self, name):
        """accessor"""
        self.__Name = name

    def getArg(self):
        """accessor"""
        return self.__Arg

    def setArg(self, arg):
        """accessor"""
        self.__Arg = arg

    def getType(self):
        """accessor"""
        return self.__Type

    ## DEBUG ##
    def __str__(self):
        if (self.__Type != ""):
            return "Command: `" + self.__Name + "' with args `" + self.__Arg \
                   + "' on: " + self.__Type
        else:
	    return "Command: `" + self.__Name + "' with args `" + self.__Arg \
                   + "'"

class TarballCmd:
    """
    Class for commands to execute in the test of a tarball.
    """
    ## CONSTRUCTOR ##
    def __init__(self, Name, Type = ""):
    	self.__Name	= Name
        self.__Type	= Type
        self.__ListCmdSuccess	= []
        self.__ListCmdFail 	= []

    ## ACCESSORS ##
    def getName(self):
        """accessor"""
        return self.__Name

    def setName(self, name):
        """accessor"""
        self.__Name = name

    def getType(self):
        """accessor"""
        return self.__Type

    def getListCmdSuccess(self):
        """accessor"""
        return self.__ListCmdSuccess

    def getListCmdFail(self):
        """accessor"""
        return self.__ListCmdFail

    def AddCmdFail(self, Name, Arg = "", Type = ""):
        """accessor"""
        self.__ListCmdFail.append(CmdTask(Name, Arg, Type))

    def AddCmdSuccess(self, Name, Arg = "", Type = ""):
        """accessor"""
        self.__ListCmdSuccess.append(CmdTask(Name, Arg, Type))

    ## DEBUG ##
    def __str__(self):
        StrCmdSuccess 	= "      Command for success:\n"
	StrCmdFail	= "      Command for fail:\n"

	for i in self.__ListCmdSuccess:
	    StrCmdSuccess += "\t" + str(i) + "\n"
	for i in self.__ListCmdFail:
	    StrCmdFail += "\t" + str(i) + "\n"
	if (self.__Type != ""):
            return "Tarball command: `" + self.__Name + "' on " + self.__Type + "\n" + StrCmdSuccess + StrCmdFail
	else:
            return "Tarball command: `" + self.__Name + "\n" + StrCmdSuccess + StrCmdFail


