#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# $Id: TestLog.py,v 1.1 2004/01/10 15:13:06 nes Exp $

import time

class TestLog:
    """
    Class representing all the logs for a tarball on a host.
    """
    ## CONSTRUCTOR ##
    def __init__ (self, tarball_name, class_name, host_name, logs = None):
        """
        @param tarball : the tarball to work with.
        @param host    : the host to work with.
        @param logs    : a list of logs.
        @type logs     : list of TestLogCommand objects.
        """
        self.__tarball_name = tarball_name
        self.__class_name = class_name
        self.__host_name = host_name
        self.__logs = logs or []
        self.__status = "OK"
        self.setDate ()
        self.setTime ("0m0.000s")
        self.__summary = "No information."

    def __del__(self):
        self.__status = "OK"
        self.__logs = None

    ## ACCESSORS ##
    def getTarballName (self):
        return self.__tarball_name

    def getHostName (self):
        """accessor"""
        return self.__host_name

    def getClassName (self):
        """accessor"""
        return self.__class_name

    def getLogs (self):
        """accessor"""
        return self.__logs

    def setLogs (self, logs):
        """
        accessor
        @param logs : a list of logs to use.
        @type logs  : list of TestLogCommand objects.
        """
        self.__logs = logs

    def addLog (self, log):
        """
        accessor
        @param log : a log to add.
        @type log  : TestLogCommand object.
        """
        self.__logs.append (log)

    def setDate (self):
        """accessor"""
        self.__date = time.strftime("%a, %d %b %Y %H:%M:%S")

    def getDate (self):
        """accessor"""
        return self.__date

    def setTime (self, time):
        self.__Time = time

    def getTime (self):
        """accessor"""
        return self.__Time

    def setFail (self):
        """accessor"""
        self.__status = "FAILED"

    def setNotTested (self):
        """accessor"""
        self.__status = "NOT TESTED"

    def getStatus (self):
        """accessor"""
        return self.__status

    def setSummary (self, summary):
        """accessor"""
        self.__summary = summary

    def getSummary (self):
        """accessor"""
        return self.__summary
