#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
# $Id: TestLogCommand.py,v 1.2 2004/01/10 17:00:21 nes Exp $

from core.TarballCommand import CmdTask

class TestLogCommand:
    """
    Class representing an executed command and its results (exit status,
    output, ...).
    """
    ## CONSTRUCTOR ##
    def __init__ (self, Name, Type, Status = 0, Output = "", ListInfos = None):
        """
        @param Name      : the command.
        @param Type      : the type of the command (local, remote, special
        or error).
        @param Status    : the exit status of the command.
        @param Output    : the output of the command.
        @param ListInfos : the list of informations about the command.
        """
    	self.__Name = Name
        self.__Type = Type
        self.__Status = Status
        self.__Output = Output
        self.__ListInfos = ListInfos or []

    ## ACCESSORS ##
    def getName (self):
        """accessor"""
        return self.__Name

    def getType (self):
        """accessor"""
        return self.__Type

    def getStatus (self):
        """accessor"""
        return self.__Status

    def getOutput (self):
        """accessor"""
        return self.__Output

    def getListInfos (self):
        """accessor"""
        return self.__ListInfos

    def AddCmd(self, Name, Arg = "", Type = ""):
        """
        Method to add a information command to the command.
        @param Name : the name of the information (print, fetch, abort).
        @param Arg  : the argument of the information (a file for fetch).
        @param Type : the type of the information (local or remote).
        """
        self.__ListInfos.append (CmdTask (Name, Arg, Type))

    ## DEBUG ##
    def __str__(self):
        StrInfos = "      Infos:\n"

	for i in self.__ListInfos:
	    StrInfos += "\t" + str(i) + "\n"
        return "TestLogCommand: `" + self.__Name + "' on " + self.__Type + "\n" \
               + "      Exit with %d\n" + StrInfos % self.__Status
