#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: TestLogParser.py,v 1.1 2004/01/10 15:13:06 nes Exp $

# FIXME: this code is not very elegant.

import xml.parsers.expat

## FIXME: This is ugly, and is too much dedicated to the current
## syntax of vampire logs. It should be written more generically.
class TestLogParser:
    """
    Transform vampire xml log into an handy representation.

    The representation is a list of tests.
    Each test is a dictionary whose keys are the xml tags and values
    the associated values.

    Example: [ {'tarball' : foo.tar.gz, 'class' : linux, .. },
               {'tarball' : bar.tar.gz, 'class' : openbsd, .. } ]

    There is an exception, test['cmd'] is a list of command dictionaries.
    Each command dictionnary may contain an `infos' field, which a
    list of strings, each info corresponding to the infos associated
    to the concerned command.
    """
    def __init__(self):
        self.__tests = []
        self.__current_placeholder = None
        self.__current_field = None
        self.__current_field_has_data = False

    def __startElementHandler(self, name, attrs):
        self.__current_field = name

        if name == "tests":
            self.__current_placeholder = {}
            self.__tests.append(self.__current_placeholder)
            self.__current_field_has_data = False
        elif name == "cmd":
            if not self.__current_placeholder.has_key('cmd'):
                self.__current_placeholder['cmd'] = []
            new_cmd = {}
            self.__current_placeholder['cmd'].append(new_cmd)
            self.__current_placeholder = new_cmd
            self.__current_field_has_data = False
	elif name == "infos":
	    self.__current_placeholder['infos'] = []
	elif name == "info":
            info = ""
	    self.__current_placeholder['infos'].append(info)
        elif name != "logs":
            self.__current_field_has_data = True
            self.__current_placeholder[self.__current_field] = ""

    def __dataHandler(self, data):
        new_str = data.strip(" ")

        if self.__current_field == "info":
	    self.__current_placeholder['infos'][-1] += new_str

	elif self.__current_field_has_data:
            self.__current_placeholder[self.__current_field] += new_str

    def __endElementHandler(self, name):
        if name == "cmd":
            self.__current_placeholder = self.__tests[-1]
	elif name == "info":
	    self.__current_placeholder = self.__tests[-1]['cmd'][-1]
	elif name == "infos":
	    self.__current_placeholder = self.__tests[-1]['cmd'][-1]
        elif self.__current_field_has_data:
            s = self.__current_placeholder[self.__current_field].strip()
            s = s.encode("latin-1")
            self.__current_placeholder[self.__current_field] = s
        self.__current_field_has_data = False
	self.__current_field = None

    def parse(self, file):
        p = xml.parsers.expat.ParserCreate()
        p.StartElementHandler = self.__startElementHandler
        p.EndElementHandler = self.__endElementHandler
        p.CharacterDataHandler = self.__dataHandler
        p.ParseFile(open(file))
        return self.__tests
