#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: TestLogTextSummaryOutput.py,v 1.1 2004/01/11 16:24:52 nes Exp $

def centerize(str, size):
    if (len(str) > size):
        str = str[0:size - 2]
    nb_spaces = (size - len(str)) / 2
    return " " * nb_spaces + str + " " * (size - nb_spaces - len(str))

class TestLogTextSummaryOutput:
    def __init__(self, logs, fields, stream):
        self._logs = logs
        self._fields = fields
        self._stream = stream
        self._nb_chars = 0
        for name, size in fields:
            self._nb_chars += size

    def print_line(self):
        self._stream.write("+" + "-" * (self._nb_chars
                                        + len(self._fields) * 2) + "+\n")

    def print_title(self):
        for name, size in self._fields:
            centered_title = centerize(name.upper(), size)
            self._stream.write("| %s" % centered_title)
        self._stream.write(" |\n")

    def print_data(self, values):
        for name, size in self._fields:
            self._stream.write("| %s" % centerize(values[name], size))
        self._stream.write(" |\n")
        self.print_line()

    def Write(self):
        # Header
        self.print_line()
        self.print_title()
        self.print_line()
        self.print_line()

        for test in self._logs:
            self.print_data(test)
