#!/usr/bin/env python

#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    $Id: check-vampire.py,v 1.11 2004/01/11 21:23:27 nes Exp $

import getopt, sys
import traceback
import testxml, test_remote_access, test_remote_upload, test_tarball_upload, \
       test_remote_test, testxml_elements, test_parse_opt
from checkprimitives import *

VAMPIRESRC="../src/"
VAMPIRE="../src/vampire.py"

def main():
    res = (0, 0)
    if (len(sys.argv) == 1):
        test_all = 1
    else:
        test_all = 0
    dummy, args = getopt.getopt(sys.argv[1:], "::");
    if (test_all == 1):
        args = ["all"]
    for a in args:
        if ((a == "xml") | (test_all == 1)):
            res = add_tuple(res, testxml.test(VAMPIRE, VAMPIRESRC))
        if ((a == "xml_elts") | (test_all == 1)):
            res = add_tuple(res, testxml_elements.test(VAMPIRE, VAMPIRESRC))
        if ((a == "remote-access") | (test_all == 1)):
            res = add_tuple(res, test_remote_access.test(VAMPIRE, VAMPIRESRC))
        if ((a == "remote-upload") | (test_all == 1)):
            res = add_tuple(res, test_remote_upload.test(VAMPIRE, VAMPIRESRC))
        if ((a == "tarball-upload") | (test_all == 1)):
            res = add_tuple(res, test_tarball_upload.test(VAMPIRE, VAMPIRESRC))
        if ((a == "remote-test") | (test_all == 1)):
            res = add_tuple(res, test_remote_test.test(VAMPIRE, VAMPIRESRC))
        if ((a == "parse-opt") | (test_all == 1)):
            res = add_tuple(res, test_parse_opt.test(VAMPIRE, VAMPIRESRC))
    print "----- FINAL RESULT : %d / %d" % (res[0], res[1])
      

try:
    main()
except:
    print "Unexpected exception caught."
    for line in traceback.format_exception(*sys.exc_info()):
        print (line.rstrip("\n"))
