#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: test_parse_opt.py,v 1.4 2004/01/11 21:23:27 nes Exp $

import os
import common
from misc import parse_opt
from checkprimitives import *


def tester(vampire, opt, expected_exit, notexp):

    exit_status = os.system(vampire + opt + " 2>&1 > /dev/null") / 256
    print vampire + opt, "EXIT:", exit_status, "EXPECT:", expected_exit
    if getint_res(exit_status, expected_exit, notexp):
        return (1, 1)
    else:
        return (1, 0)


def test(vampire, vampiresrc):
    print "===== TESTING PARSE_OPT MODULE"
    (n, nok) = (0, 0)
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -v", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -n", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -p 12 check", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -p z", common.EXIT_CMDLINE, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -H toto", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -t abc.tgz", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -q default", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -V", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -h", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -o toto", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " --version", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " check", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -v -n -p 12 --tarball-class=default check a.tgz", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " check a.tgz", common.EXIT_CMDLINE, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " -q default check a.tgz", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " check", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                           " ", 0, 0))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + "parse_opt.py",
                                          " toto", common.EXIT_CMDLINE, 0))

    print "===== RESULT       : %d / %d" % (nok, n)
    return (nok, n)
