#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: test_remote_test.py,v 1.4 2004/01/11 21:23:27 nes Exp $

import os, re, threading
import commands
from checkprimitives import *
from core.RemoteTest import *
from core import FinalHost, FinalTarball
from conf.host_conf_parser import HostConfParser
from conf.tarball_conf_parser import TarballConfParser

##########################################################################

nok = n = 0

# FIXME: Refaire un module de test ou l'on peut 'facilement' rajouter
# des tests

def OK(str):
    global n, nok
    n += 1
    nok += 1
    print_line(n, str, getstr_res(0, 0, 0));

def FAILED(str):
    global n
    n += 1
    print_line(n, str, getstr_res(0, 1, 0));

def PRINT_ERROR(got, expected):
    print "---- BEGIN ERROR GOT : ----"
    print got
    print "---- EXPECTED        : ----"
    print expected
    print "---- END         ERROR ----"

def PRINT_EXIT_STATUS(got, expected):
    print "---- EXIT STATUS : %d - EXPECTED : %d ----" % (got, expected)

##########################################################################

def test(vampire, vampiresrc):
    print "===== TESTING REMOTE TEST MODULE"

    try:
        os.mknod ("/tmp/rut")
    except OSError, arg:
        pass
    try:
        os.mkdir ("/tmp/vampire_tests1")
    except OSError, arg:
        pass
    try:
        os.mkdir ("/tmp/vampire_tests2")
    except OSError, arg:
        pass
    try:
        os.mkdir ("/tmp/vampire_tests3")
    except OSError, arg:
        pass

    # 1st test
    hosts = HostConfParser ("./remote_test/host_test1.xml")
    tarballs = TarballConfParser ("./remote_test/tarball_test1.xml")
    FinalHostList = FinalHost.transform (hosts.GetListClass (),
                                         hosts.GetListHost ())
    FinalTarballList = FinalTarball.transform (tarballs.GetListClass (),
                                               tarballs.GetListTarball ())
    logtarball = LogTarball (FinalTarballList[0], FinalHostList[0])
    cond = threading.Condition ()
    r = RemoteTest (logtarball, cond)
    r.start ()
    cond.acquire ()
    cond.wait ()
    type = "ok"
    for i in logtarball.getLogs ():
        if i.getType () == "error":
            type = i.getType ()
            print i.getName ()
            print i.getOutput ()
            break
    if type == "ok":
        OK ("Remote test")
    else:
        FAILED ("Remote test")

    # 2nd test
    del logtarball
    hosts = parserXMLconf.ParserConf ("./remote_test/host_test2.xml")
    tarballs = parserXMLtarball.ParserTarball ("./remote_test/tarball_test1.xml")
    FinalHostList = FinalHost.transform (hosts.GetListClass (),
                                         hosts.GetListHost ())
    FinalTarballList = FinalTarball.transform (tarballs.GetListClass (),
                                               tarballs.GetListTarball ())
    logtarball = LogTarball (FinalTarballList[0], FinalHostList[0], [])
    cond = threading.Condition ()
    r = RemoteTest (logtarball, cond)
    r.start ()
    cond.acquire ()
    cond.wait ()
    type = "ok"
    for i in logtarball.getLogs ():
        if i.getType () == "error":
            type = i.getType ()
            break
    if type == "ok":
        FAILED ("Remote test error")
    else:
        OK ("Remote test error")

    # 3rd test
    del logtarball
    hosts = parserXMLconf.ParserConf ("./remote_test/host_test3.xml")
    tarballs = parserXMLtarball.ParserTarball ("./remote_test/tarball_test1.xml")
    FinalHostList = FinalHost.transform (hosts.GetListClass (),
                                         hosts.GetListHost ())
    FinalTarballList = FinalTarball.transform (tarballs.GetListClass (),
                                               tarballs.GetListTarball ())
    logtarball = LogTarball (FinalTarballList[0], FinalHostList[0], [])
    cond = threading.Condition ()
    r = RemoteTest (logtarball, cond)
    r.start ()
    cond.acquire ()
    cond.wait ()
    type = "ok"
    for i in logtarball.getLogs ():
        if i.getType () == "error":
            type = i.getType ()
            break
    if type == "ok":
        FAILED ("Remote test error")
    else:
        OK ("Remote test error")

    # 4th test
    del logtarball
    hosts = parserXMLconf.ParserConf ("./remote_test/host_test1.xml")
    tarballs = parserXMLtarball.ParserTarball ("./remote_test/tarball_test2.xml")
    FinalHostList = FinalHost.transform (hosts.GetListClass (),
                                         hosts.GetListHost ())
    FinalTarballList = FinalTarball.transform (tarballs.GetListClass (),
                                               tarballs.GetListTarball ())
    logtarball = LogTarball (FinalTarballList[0], FinalHostList[0], [])
    cond = threading.Condition ()
    r = RemoteTest (logtarball, cond)
    r.start ()
    cond.acquire ()
    cond.wait ()
    type = "ok"
    for i in logtarball.getLogs ():
        if i.getType () == "error":
            type = i.getType ()
            break
    if type == "ok":
        FAILED ("Remote test error")
    else:
        OK ("Remote test error")

    print "===== RESULT       : %d / %d" % (nok, n)
    return (nok, n)
