#    Copyright (C) 2003, 2004, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: test_tarball_upload.py,v 1.3 2004/01/11 21:23:27 nes Exp $

import os, re
import commands
from checkprimitives import *
from core.TarballUpload import *
from core import FinalHost
from core import FinalTarball

##########################################################################

nok = n = 0

# FIXME: Refaire un module de test ou l'on peut 'facilement' rajouter
# des tests

def OK(str):
    global n, nok
    n += 1
    nok += 1
    print_line(n, str, getstr_res(0, 0, 0));

def FAILED(str):
    global n
    n += 1
    print_line(n, str, getstr_res(0, 1, 0));

def PRINT_ERROR(got, expected):
    print "---- BEGIN ERROR GOT : ----"
    print got
    print "---- EXPECTED        : ----"
    print expected
    print "---- END         ERROR ----"

def PRINT_EXIT_STATUS(got, expected):
    print "---- EXIT STATUS : %d - EXPECTED : %d ----" % (got, expected)

##########################################################################

def test(vampire, vampiresrc):
    print "===== TESTING TARBALL UPLOAD MODULE"

    try:
        os.mknod ("/tmp/rut")
    except OSError, arg:
        pass

    # 1st test
    host = FinalHost.FinalHost ("localhost", {}, ("ssh serve", "ssh localhost"),
                                (("local", "scp /tmp/rut serve:~/"),
                                 ("distant", "scp localhost:/tmp/rut /tmp/rut2"),
                                 ("local", "scp /tmp/rut localhost:/tmp/rut3")),
                                {}, "/tmp/")
    tmpmd5 = commands.getoutput ("md5sum /tmp/rut | cut -d \" \" -f1")
    tarball = FinalTarball.FinalTarball ("/tmp/rut", "none", {}, [], "none",
                                         tmpmd5)
    tu = TarballUpload (host, tarball)
    try:
        tu.send ()
    except TarballUploadError, e:
        FAILED ("Tarball upload: " + e.str)
    else:
        OK ("Tarball uploaded")

    # 2nd test
    host = FinalHost.FinalHost ("localhost", {}, ("ssh localhost", ""),
                                (("local",
                                  "scp /tmp/rut localhost:/tmp/rut3"), ""),
                                {}, "/tmp/", "none", False, "", "md5sum_bad")
    tu = TarballUpload (host, tarball)
    try:
        tu.send ()
    except TarballUploadError, e:
        FAILED ("Upload error: " + e.str)
    else:
        OK ("Invalid check")

    # 3rd test
    host = FinalHost.FinalHost ("invalid_host", {}, ("ssh invalid_host", ""),
                                (("local",
                                  "scp /tmp/rut invalid_host:/tmp/rut3"), ""),
                                {}, "/tmp/", "none", False, "", "md5sum_bad")
    tu = TarballUpload (host, tarball)
    try:
        tu.send ()
    except TarballUploadError, e:
        OK ("Invalid upload")
    else:
        FAILED ("Invalid upload")

    # 4th test
    host = FinalHost.FinalHost ("invalid_host", {}, ("ssh invalid_host", ""),
                                (("distant",
                                  "scp invalid_host:/tmp/rut /tmp/rut3"), ""),
                                {}, "/tmp/", "none", False, "", "md5sum_bad")
    tu = TarballUpload (host, tarball)
    try:
        tu.send ()
    except TarballUploadError, e:
        OK ("Invalid download")
    else:
        FAILED ("Invalid download")

    # 5th test
    host = FinalHost.FinalHost ("localhost", {}, ("ssh serve", "ssh localhost"),
                                (("local", "scp /tmp/rut serve:~/"),
                                 ("distant", "scp localhost:/tmp/rut /tmp/rut2"),
                                 ("local", "scp /tmp/rut localhost:/tmp/rut3")),
                                {}, "/tmp/", "none", False, "",
                                "md5sum /tmp/rut2 | cut -d \" \" -f1")
    tarball = FinalTarball.FinalTarball ("/tmp/rut", "none", {}, [], "none",
                                         "invalid md5")
    tu = TarballUpload (host, tarball)
    try:
        tu.send ()
    except TarballUploadError, e:
        OK ("Invalid Md5 check")
    else:
        FAILED ("Invalid Md5 check")

    print "===== RESULT       : %d / %d" % (nok, n)
    return (nok, n)
