#!/usr/bin/env python

#    Copyright (C) 2003, Vampire Team <vampire-public@nongnu.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    $Id: testxml.py,v 1.12 2003/09/19 12:01:14 maxme Exp $

import os, re
from checkprimitives import *

def one_test(vampire, nbr, filename, exp, notexp):
    #FIXME: why do i need to divide by 256 ???
    exit_status = os.system(vampire + filename
                            + " 2>&1 > /dev/null") / 256
    print_line(nbr, filename, getstr_res(exit_status, exp, notexp));
    return getint_res(exit_status, exp, notexp)

def tester(vampire, opt, dir, exp, notexp, ext, n):
    """
    vampire     : the path to the vampire executable
    dir         : directory where the test files are
    exp         : exit status expected (or not)
    notexp      : the exit status, exp, is NOT expected
    n           : number of test already checked
    ext         : extension of files to test
    """
    res = nbr = 0
    try:
        list = os.listdir(dir)
    except os.error, e:
        print e
    else:
        for file in list:
            m = re.match("(.*)\.%s$" % ext, file)
            if m:
                nbr = nbr + 1
                res = res + one_test(vampire + opt,
                                     nbr + n, dir + "/" + file, exp, notexp)
    return (nbr, res)

def test(vampire, vampiresrc):
    print "===== TESTING XML VALIDATING"
    (n, nok) = (0, 0)
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + \
               " parserXMLconf.py", " ", "parse/hosts/good", 2, 1, "xml", n))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + \
               "parserXMLconf.py", " ", "parse/hosts/bad", 2, 0, "xml", n))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + \
           "parserXMLtarball.py", " ","parse/tarballs/good", 2, 1, "xml", n))
    (n, nok) = add_tuple((n, nok), tester("python " + vampiresrc + \
           "parserXMLtarball.py", " ","parse/tarballs/bad", 2, 0, "xml", n))
    print "===== RESULT       : %d / %d" % (nok, n)
    return (nok, n)
